function [ff,err1,err2,pp_prime]=err_func(pp,y,x,eps1,eps2,beta,pie,gam,cheb,ss,pc,ad,dp)

if dp == 1
    if length(y) ~= length(x)
        error('fatal (err_func) length of x and y should be equal')
    end
    if max(abs(x-y)) > .1e-10
        error('fatal (err_func) x and y should be equal')
    end
end

M=length(pp)/2;
if round(M)*2 ~= length(pp)
    error('fatal (err_func) length of pp must be divisible by 2')
end

a=abs(pp(1:M));
b=abs(pp(M+1:2*M));
err1=zeros(length(x),1);
err2=zeros(length(x),1);
N=length(eps1);

if cheb == 1
    [P1] = chebyshev(x,M,a);
    [P2] = chebyshev(x,M,b);
else
    %basis: a=F(y), desired: P1=F(x)
    P1=interp1(y,a,x,ss,'extrap');
    P2=interp1(y,b,x,ss,'extrap');
end

for ii = 1:length(x)
    
    xp=eps1*x(ii)./(x(ii)*eps1+(1-x(ii))*eps2);
    if cheb == 1
        [P1jj] = chebyshev(xp,M,a);
        [P2jj] = chebyshev(xp,M,b);
    else
        P1jj=interp1(y,a,xp,ss,'extrap');
        P2jj=interp1(y,b,xp,ss,'extrap');
    end
    if pc == 1
        ss1=beta*pie(1,:)*((x(ii)*eps1+(1-x(ii))*eps2).^(1-gam).*(xp+P1jj));
        ss2=beta*pie(1,:)*((x(ii)*eps1+(1-x(ii))*eps2).^(1-gam).*(1-xp+P2jj));
    else
        ss1=beta*pie(1,:)*((x(ii)*eps1+(1-x(ii))*eps2).^(-gam).*(1+P1jj).*eps1);
        ss2=beta*pie(1,:)*((x(ii)*eps1+(1-x(ii))*eps2).^(-gam).*(1+P2jj).*eps2);
    end
    
    if dp == 0
        err1(ii)=P1(ii)-ss1;
        err2(ii)=P2(ii)-ss2;
    elseif dp == 1
        P1(ii)=ss1;
        P2(ii)=ss2;
    end
end

ff=ad*[err1;err2];
pp_prime=[P1;P2];