function [M1,M2,R,corr,V1,V2,Cov,P1,P2] = moments(x,a,b,M,y,ss,N,eps1,eps2,pie,pc,cheb,bet,gam)

if cheb == 1
    [P1] = chebyshev(x,M,a);
    [P2] = chebyshev(x,M,b);
else
    %a=F(y), where y and a are given. Then, interpolation is done to compute P1=F(x).
    P1=interp1(y,a,x,ss,'extrap');
    P2=interp1(y,b,x,ss,'extrap');
end

lx=length(x);
M1  = zeros(lx,1);
M2  = zeros(lx,1);
R   = zeros(lx,1);
Cov = zeros(lx,1);
V1  = zeros(lx,1);
V2  = zeros(lx,1);
    

for ii = 1:lx
    
    %compute every possible ex post realized return for the given value of x
    %also, compute the ex ante mean across them
    xp=eps1*x(ii)./(x(ii)*eps1+(1-x(ii))*eps2);
    if cheb == 1
        [P1jj] = chebyshev(xp,M,a);
        [P2jj] = chebyshev(xp,M,b);
    else
        P1jj=interp1(y,a,xp,ss,'extrap');
        P2jj=interp1(y,b,xp,ss,'extrap');
    end
    if pc == 1
        R1=(xp+P1jj)  .*(x(ii)*eps1+(1-x(ii))*eps2)/P1(ii);
        R2=(1-xp+P2jj).*(x(ii)*eps1+(1-x(ii))*eps2)/P2(ii);
    else
        R1=(1+P1jj).*eps1/P1(ii);
        R2=(1+P2jj).*eps2/P2(ii);
    end
    R(ii)=1/(bet*pie(1,:)*((x(ii)*eps1+(1-x(ii))*eps2).^(-gam)));
    M1(ii)=pie(1,:)*R1;
    M2(ii)=pie(1,:)*R2;
    
    Cov(ii)=pie(1,:)*((R1-M1(ii)).*(R2-M2(ii)));
    V1(ii)= pie(1,:)*((R1-M1(ii)).^2);
    V2(ii)= pie(1,:)*((R2-M2(ii)).^2);
    
    corr(ii)=Cov(ii)/sqrt(V1(ii)*V2(ii));
    
end