close all
clear all
dbstop if error

gam=2;
sig=sqrt(.06);
bet=0.96;
mu=0.02;

M=500;%number of grid points to do the calculations on.
pc=1;%if unity, compute the price-consumption ratio for the two trees; otherwise, price dividend.
cheb=0;%if unity, do Chebyshev approximation, otherwise do finite-element using MATLAB interp1
norun=2;%if unity, don't run fsolve, just load solution and verify that it's attached to the right parameters
        %if zero, run fsolve and solve the model by projection
        %if 2, solve by dynamic programming.
cheb_grid=1;%if unity, construct grid using chebyshev zeros, otherwise equally spaced points.
ut = 'cheb_grid500';%extension on names of files


pi1=[1/8 6/8 1/8
    1/8 6/8 1/8
    1/8 6/8 1/8];

pi1=ones(3)/3;

pi2=pi1;


if norun == 2
    dp=1;
else
    dp=0;
end

pie=kron(pi1,pi2);

ad=10000000;%multiply the Euler error by this scalar when solving the system using fsolve
if cheb == 0
    ss='spline';%for reasons unknown (unknowable?) this thing always does 'spline'
else
    ss=[];
end

if cheb_grid == 1
    %set up the grid on x using Chebyshev zeros.
    
    jj=[1:M]';
    r=cos(4*atan(1)*(jj-1/2)/M);   %i want to make sure that pi is pi....and has not been reset somewhere
    r=sort(r);
    x=(r+1)/2;
    
else
    
    x_min=.0001;
    x_max=1-x_min;
    x=linspace(x_min,x_max,M)';
    
end


eps1=[-sig
    -sig
    -sig
    0
    0
    0
    sig
    sig
    sig];

eps2=[-sig
    0
    sig
    -sig
    0
    sig
    -sig
    0 
    sig];

eps1=1+mu+eps1;
eps2=1+mu+eps2;
N=length(eps1);

a=bet/(1-bet)*ones(M,1)/2;
b=a;
pp=[a;b];
y=x;

if norun == 1
    
    yy=y;
    eeps1=eps1;
    eeps2=eps2;
    bbet=bet;
    ppie=pie;
    ggam=gam;
    ccheb=cheb;
    ppc=pc;
    aad=ad;
    
    load results_1 x_old x xx y eps1 eps2 e1 e2 bet pie gam cheb ss pc ad fval exitflag V1 V2 Cov corr M1 M2 P1 P2
    %veriy that model whose solution was just loaded corresponds to the
    %model set above
    if max(abs(x_old-y)) > .1e-10 || max(abs(yy-y)) > .1e-10 || max(abs(eeps1-eps1)) > .1e-10 ...
            || max(abs(eeps2-eps2)) > .1e-10 || max(abs(bbet-bet)) > .1e-10 ...
            || max(max(abs(ppie-pie))) > .1e-10 || max(abs(ggam-gam)) > .1e-10 || max(abs(ccheb-cheb)) > .1e-10 ...
            || max(abs(ppc-pc)) > .1e-10 || max(abs(aad-ad)) > .1e-10
        error('fatal (moretrees) parameters in load file not exactly the same as what is set in program')
    end
    
    [ff,e1,e2]=err_func(xx,y,x_old,eps1,eps2,bet,pie,gam,cheb,ss,pc,ad,dp);
    
    if max(abs(ff-fval)) > .2e-10
        error('fatal (moretrees) loaded parameters seem not to solve model')
    end
    
elseif norun == 0
    tic
    [xx,fval,exitflag]=fsolve('err_func',pp,optimset('Algorithm','trust-region-reflective', ...
        'MaxFunEvals',10000,'maxiter',10000,'Display','iter','TolFun',.1e-10,'TolX',.1e-10) ...
        ,y,x,eps1,eps2,bet,pie,gam,cheb,ss,pc,ad,dp);
    toc
    if exitflag <= 0
        disp(' warning(moretrees) did not converge properly')
    end
    
    [ff,e1,e2]=err_func(xx,y,x,eps1,eps2,bet,pie,gam,cheb,ss,pc,ad,dp);
    x_old=x;
    
    
    a=abs(xx(1:M));
    b=abs(xx(M+1:2*M));
    
    x=[.001:.001:.99]';
    
    x=[[.0001:.0001354:.042]';x;1-[.0001:.0001354:.042]'];
    x=sort(x);
    [sq I]=min(abs(diff(x)));
    if sq < .1e-7
        error('fatal (moretrees) two grid points virtually the same')
    end
    
    if y(1) < x(1)
        x=[y(1);x];
    end
    if y(end)>x(end)
        x=[x;y(end)];
    end
    
    [M1,M2,R,corr,V1,V2,Cov,P1,P2] = moments(x,a,b,M,y,ss,N,eps1,eps2,pie,pc,cheb,bet,gam);
    
    save results x_old x xx y eps1 eps2 e1 e2 bet pie gam cheb ss pc ad fval exitflag V1 V2 Cov corr M1 M2 P1 P2 R
  
elseif norun == 2
  
    ix=0;
    sf=10;
    tic
    while sf > .1e-8 && ix < 1000
        [ff,e1,e2,pp_prime]=err_func(pp,y,x,eps1,eps2,bet,pie,gam,cheb,ss,pc,ad,dp);
        [sf,temp]=max(abs(pp_prime-pp));
        pp=pp_prime;
        ix=ix+1;
        sf;
        fprintf('.')
        if mod(ix,100)==0
            fprintf(' sf = %5.3e, ix = %4i\n',sf,ix);
        end
    end
    toc
    a=abs(pp(1:M));
    b=abs(pp(M+1:2*M));
    x_old=x;
    x=[.001:.001:.99]';
    
    x=[[.0001:.0001354:.042]';x;1-[.0001:.0001354:.042]'];
    x=sort(x);
    [sq I]=min(abs(diff(x)));
    if sq < .1e-7
        error('fatal (moretrees) two grid points virtually the same')
    end
    
    if y(1) < x(1)
        x=[y(1);x];
    end
    if y(end)>x(end)
        x=[x;y(end)];
    end
    
    [M1,M2,R,corr,V1,V2,Cov,P1,P2] = moments(x,a,b,M,y,ss,N,eps1,eps2,pie,pc,cheb,bet,gam);
    xx=pp;fval=sq;exitflag=[];
    
    ff=['save results_',ut,' x_old x xx y eps1 eps2 e1 e2 bet pie gam cheb ss pc ad fval exitflag V1 V2 Cov corr M1 M2 P1 P2 R'];
    eval(ff);
    
end

figure('name','moments')
ia=2;
ib=3;
subplot(ia,ib,1)
plot(x,corr)
title('correlation between two returns')
axis tight

subplot(ia,ib,2)
plot(x,P1,x,P2)
legend('tree 1','tree 2')
if pc == 1
    title('(weighted) price/consumption ratio')
else
    title('price/dividend ratio')
end
axis tight

subplot(ia,ib,3)
plot(x,M1,x,M2,'--',x,R,'-.',x,ones(length(x),1)*(1+mu)^gam/bet)
h_legend=legend('Mean return tree 1','Mean return, tree 2','Risk free rate','Risk free rate absent uncertainty','Location','South');
set(h_legend,'FontSize',6);
title('Gross Returns')
axis tight


if pc == 1
    subplot(ia,ib,4)
    plot(x,P1./x,x,P2./(1-x))
    legend('tree 1','tree 2')
    title('price/dividend ratio')
    axis tight
end

[ff,err1,err2]=err_func(xx,y,x,eps1,eps2,bet,pie,gam,cheb,ss,pc,ad,0);
subplot(ia,ib,5)
plot(x,err1,x_old,e1,'*')
legend('fine grid','grid used for computations','Location','Best')
title('error function for tree 1')
axis tight

[Y,I]=min(abs(x-.2));
tt=1:I;
[Y,I]=min(abs(x_old-.2));
te=1:I;
subplot(ia,ib,6)
plot(x(tt),err1(tt),x_old(te),e1(te),'*',x(tt),zeros(length(tt),1))
title('close up: error function for tree 1')
axis tight
orient landscape
zz=['gam = ',num2str(gam),', sig = ',num2str(sig),', bet = ',num2str(bet),', mu = ',num2str(mu)];
suptitle(zz);
ff=['moments_',ut];
print('-dpdf',ff)

1+1;