%this does simulations on the unit root two tree model
close all
clear all

sig=sqrt(.06);
mu=.02;

eps1=[-sig
    -sig
    -sig
    0
    0
    0
    sig
    sig
    sig];

eps2=[-sig
    0
    sig
    -sig
    0
    sig
    -sig
    0 
    sig];

eps1=1+mu+eps1;
eps2=1+mu+eps2;

load results_cheb_grid500 x_old x xx y eps1 eps2 e1 e2 bet pie gam cheb ss pc ad fval exitflag V1 V2 Cov corr M1 M2 P1 P2 R
xq=x;

for jj = 1:1
    n = unidrnd(9,100,1);
    x=zeros(length(n),1);
    ER1=zeros(length(n),1);
    ER2=zeros(length(n),1);
    correl=zeros(length(n),1);
    Rate=zeros(length(n),1);
    PC1=zeros(length(n),1);
    PC2=zeros(length(n),1);
    PD1=zeros(length(n),1);
    PD2=zeros(length(n),1);
    gr = zeros(length(n),1);
    x(1)=1/2;
    gr(1)=1+mu;
    
    for ii = 2:length(n)
        x(ii)=eps1(n(ii))*x(ii-1)/(x(ii-1)*eps1(n(ii))+(1-x(ii-1))*eps2(n(ii)));
        %basis: M1=F(xq), desired: P1=F(x(ii))
        
        %basis: a=F(y), desired: P1=F(x)
        %P1=interp1(y,a,x,ss,'extrap');
        
        ER1(ii)=interp1(xq,M1,x(ii),ss,'extrap');
        ER2(ii)=interp1(xq,M2,x(ii),ss,'extrap');
        correl(ii)=interp1(xq,corr,x(ii),ss,'extrap');
        Rate(ii)=interp1(xq,R,x(ii),ss,'extrap');
        PC1(ii)=interp1(xq,P1,x(ii),ss,'extrap');
        PC2(ii)=interp1(xq,P2,x(ii),ss,'extrap');
        PD1(ii)=PC1(ii)/x(ii);
        PD2(ii)=PC2(ii)/(1-x(ii));
        gr(ii) = x(ii-1)*eps1(n(ii))+(1-x(ii-1))*eps2(n(ii));
    end
    
    lC=cumsum(log(gr));
    lw=log(PC1+PC2+1)+lC;
    f=1./(PC1+PC2+1);
    ia=2;
    ib=3;
    lw=lw-lw(2);
    lC=lC-lC(2);
  
    tt=2:length(n);
    subplot(ia,ib,1)
    [d,t]=hpfast(cumsum(log(gr)),1600);
    plot(tt,ER1(tt)-1,tt,ER2(tt)-1,'*-',tt,Rate(tt)-1,'+-')
    legend('expected R1','expected R2','R')
    axis tight
    subplot(ia,ib,2)
    plot(tt,x(tt),tt,correl(tt),'x-',tt,d(tt),'o-')
    legend('x','correlation','HP filtered consumption level')
    subplot(ia,ib,4)
    plot(tt,PC1(tt),tt,PC2(tt),'x-')
    legend('(weighted) price consumption ratio tree 1','tree 2')
    axis tight
    subplot(ia,ib,5)
    plot(tt,PD1(tt),tt,PD2(tt),'x-')
    legend('price dividend ratio, tree 1','tree 2')
    axis tight
    subplot(ia,ib,6)
    plot(tt,lw(tt),tt,lC(tt))
    legend('log (scaled) wealth','log (scaled) consumption')
    axis tight
    subplot(ia,ib,3)
    plot(tt,f(tt))
    title('C/w')
    axis tight
    
    orient landscape
    ss='simulation_gam2';
    print('-dpdf',ss);
%    pause
    
end